Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableSortedMap<K,V>

    java.lang.Object
      com.google.common.collect.ImmutableMap<K,V>
          com.google.common.collect.ImmutableSortedMap<K,V>

All Implemented Interfaces:
  Serializable, Map<K,V>, SortedMap<K,V>

    @GwtCompatible(serializable=true,
                   emulated=true)
    public class ImmutableSortedMap<K,V>

extends ImmutableMap<K,V>
implements SortedMap<K,V>

An immutable `SortedMap`. Does not permit null keys or values.

Unlike `Collections.unmodifiableSortedMap(java.util.SortedMap)`, which is a view of a separate map which can still change, an instance of `ImmutableSortedMap` contains its own data and will never change. `ImmutableSortedMap` is convenient for `public static final` maps ("constant maps") and also lets you easily make a "defensive copy" of a map provided to your class by a caller.

Note: Although this class is not final, it cannot be subclassed as it has no public or protected constructors. Thus, instances of this class are guaranteed to be immutable.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Jared Levy, Louis Wasserman
See Also:
  Serialized Form

Nested Class Summary
`static class` | `ImmutableSortedMap.Builder<K,V>` A builder for creating immutable sorted map instances, especially `public static final` maps ("constant maps").

Nested classes/interfaces inherited from interface java.util.Map
`Map.Entry<K,V>`

Method Summary
`static
`<K,V> ImmutableSortedMap.Builder<K,V>`
` | `builder()` Deprecated. Use `naturalOrder()`, which offers better type-safety.
`Comparator<? super K>` | `comparator()` Returns the comparator that orders the keys, which is `Ordering.natural()` when the natural ordering of the keys is used.
`boolean` | `containsValue(Object value)`
`static
`<K,V> ImmutableSortedMap<K,V>`
` | `copyOf(Map<? extends K,? extends V> map)` Returns an immutable map containing the same entries as `map`, sorted by the natural ordering of the keys.
`static
`<K,V> ImmutableSortedMap<K,V>`
` | `copyOf(Map<? extends K,? extends V> map, Comparator<? super K> comparator)` Returns an immutable map containing the same entries as `map`, with keys sorted by the provided comparator.
`static
`<K,V> ImmutableSortedMap<K,V>`
` | `copyOfSorted(SortedMap<K,? extends V> map)` Returns an immutable map containing the same entries as the provided sorted map, with the same ordering.
`ImmutableSet<Map.Entry<K,V>>` | `entrySet()` Returns an immutable set of the mappings in this map, sorted by the key ordering.
`K` | `firstKey()`
`V` | `get(Object key)`
`ImmutableSortedMap<K,V>` | `headMap(K toKey)` This method returns a `ImmutableSortedMap`, consisting of the entries whose keys are less than `toKey`.
`ImmutableSortedSet<K>` | `keySet()` Returns an immutable sorted set of the keys in this map.
`K` | `lastKey()`
`static
`<K extends Comparable<K>,V> ImmutableSortedMap.Builder<K,V>`
` | `naturalOrder()` Returns a builder that creates immutable sorted maps whose keys are ordered by their natural ordering.
`static
`<K,V> ImmutableSortedMap<K,V>`
` | `of()` Returns the empty sorted map.
`static
`<K extends Comparable<? super K>,V> ImmutableSortedMap<K,V>`
` | `of(K k1, V v1)` Returns an immutable map containing a single entry.
`static
`<K extends Comparable<? super K>,V> ImmutableSortedMap<K,V>`
` | `of(K k1, V v1, K k2, V v2)` Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.
`static
`<K extends Comparable<? super K>,V> ImmutableSortedMap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.
`static
`<K extends Comparable<? super K>,V> ImmutableSortedMap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.
`static
`<K extends Comparable<? super K>,V> ImmutableSortedMap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.
`static
`<K,V> ImmutableSortedMap.Builder<K,V>`
` | `orderedBy(Comparator<K> comparator)` Returns a builder that creates immutable sorted maps with an explicit comparator.
`static
`<K extends Comparable<K>,V> ImmutableSortedMap.Builder<K,V>`
` | `reverseOrder()` Returns a builder that creates immutable sorted maps whose keys are ordered by the reverse of their natural ordering.
`int` | `size()`
`ImmutableSortedMap<K,V>` | `subMap(K fromKey, K toKey)` This method returns a `ImmutableSortedMap`, consisting of the entries whose keys ranges from `fromKey`, inclusive, to `toKey`, exclusive.
`ImmutableSortedMap<K,V>` | `tailMap(K fromKey)` This method returns a `ImmutableSortedMap`, consisting of the entries whose keys are greater than or equals to `fromKey`.
`ImmutableCollection<V>` | `values()` Returns an immutable collection of the values in this map, sorted by the ordering of the corresponding keys.

Methods inherited from class com.google.common.collect.ImmutableMap
`clear, containsKey, equals, hashCode, isEmpty, put, putAll, remove, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, equals, hashCode, isEmpty, put, putAll, remove`

Method Detail

### of

    public static <K,V> ImmutableSortedMap<K,V> of()

  Returns the empty sorted map.

### of

    public static <K extends Comparable<? super K>,V> ImmutableSortedMap<K,V> of(K k1,
                                                                                 V v1)

  Returns an immutable map containing a single entry.

### of

    public static <K extends Comparable<? super K>,V> ImmutableSortedMap<K,V> of(K k1,
                                                                                 V v1,
                                                                                 K k2,
                                                                                 V v2)

  Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.

  Throws:
    `IllegalArgumentException` - if the two keys are equal according to their natural ordering

### of

    public static <K extends Comparable<? super K>,V> ImmutableSortedMap<K,V> of(K k1,
                                                                                 V v1,
                                                                                 K k2,
                                                                                 V v2,
                                                                                 K k3,
                                                                                 V v3)

  Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.

  Throws:
    `IllegalArgumentException` - if any two keys are equal according to their natural ordering

### of

    public static <K extends Comparable<? super K>,V> ImmutableSortedMap<K,V> of(K k1,
                                                                                 V v1,
                                                                                 K k2,
                                                                                 V v2,
                                                                                 K k3,
                                                                                 V v3,
                                                                                 K k4,
                                                                                 V v4)

  Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.

  Throws:
    `IllegalArgumentException` - if any two keys are equal according to their natural ordering

### of

    public static <K extends Comparable<? super K>,V> ImmutableSortedMap<K,V> of(K k1,
                                                                                 V v1,
                                                                                 K k2,
                                                                                 V v2,
                                                                                 K k3,
                                                                                 V v3,
                                                                                 K k4,
                                                                                 V v4,
                                                                                 K k5,
                                                                                 V v5)

  Returns an immutable sorted map containing the given entries, sorted by the natural ordering of their keys.

  Throws:
    `IllegalArgumentException` - if any two keys are equal according to their natural ordering

### copyOf

    public static <K,V> ImmutableSortedMap<K,V> copyOf(Map<? extends K,? extends V> map)

  Returns an immutable map containing the same entries as `map`, sorted by the natural ordering of the keys.

  Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

  This method is not type-safe, as it may be called on a map with keys that are not mutually comparable.

  Throws:
    `ClassCastException` - if the keys in `map` are not mutually comparable
    `NullPointerException` - if any key or value in `map` is null
    `IllegalArgumentException` - if any two keys are equal according to their natural ordering

### copyOf

    public static <K,V> ImmutableSortedMap<K,V> copyOf(Map<? extends K,? extends V> map,
                                                       Comparator<? super K> comparator)

  Returns an immutable map containing the same entries as `map`, with keys sorted by the provided comparator.

  Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

  Throws:
    `NullPointerException` - if any key or value in `map` is null
    `IllegalArgumentException` - if any two keys are equal according to the comparator

### copyOfSorted

    public static <K,V> ImmutableSortedMap<K,V> copyOfSorted(SortedMap<K,? extends V> map)

  Returns an immutable map containing the same entries as the provided sorted map, with the same ordering.

  Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

  Throws:
    `NullPointerException` - if any key or value in `map` is null

### naturalOrder

    public static <K extends Comparable<K>,V> ImmutableSortedMap.Builder<K,V> naturalOrder()

  Returns a builder that creates immutable sorted maps whose keys are ordered by their natural ordering. The sorted maps use `Ordering.natural()` as the comparator.

  Note: the type parameter `K` extends `Comparable<K>` rather than `Comparable<? super K>` as a workaround for javac bug 6468354.

### orderedBy

    public static <K,V> ImmutableSortedMap.Builder<K,V> orderedBy(Comparator<K> comparator)

  Returns a builder that creates immutable sorted maps with an explicit comparator. If the comparator has a more general type than the map's keys, such as creating a `SortedMap<Integer, String>` with a `Comparator<Number>`, use the `ImmutableSortedMap.Builder` constructor instead.

  Throws:
    `NullPointerException` - if `comparator` is null

### reverseOrder

    public static <K extends Comparable<K>,V> ImmutableSortedMap.Builder<K,V> reverseOrder()

  Returns a builder that creates immutable sorted maps whose keys are ordered by the reverse of their natural ordering.

  Note: the type parameter `K` extends `Comparable<K>` rather than `Comparable<? super K>` as a workaround for javac bug 6468354.

### size

    public int size()

  Specified by:
    `size` in interface `Map<K,V>`

### get

    public V get(@Nullable
                 Object key)

  Specified by:
    `get` in interface `Map<K,V>`
  Specified by:
    `get` in class `ImmutableMap<K,V>`

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Specified by:
    `containsValue` in interface `Map<K,V>`
  Specified by:
    `containsValue` in class `ImmutableMap<K,V>`

### entrySet

    public ImmutableSet<Map.Entry<K,V>> entrySet()

  Returns an immutable set of the mappings in this map, sorted by the key ordering.

  Specified by:
    `entrySet` in interface `Map<K,V>`
  Specified by:
    `entrySet` in interface `SortedMap<K,V>`
  Specified by:
    `entrySet` in class `ImmutableMap<K,V>`

### keySet

    public ImmutableSortedSet<K> keySet()

  Returns an immutable sorted set of the keys in this map.

  Specified by:
    `keySet` in interface `Map<K,V>`
  Specified by:
    `keySet` in interface `SortedMap<K,V>`
  Specified by:
    `keySet` in class `ImmutableMap<K,V>`

### values

    public ImmutableCollection<V> values()

  Returns an immutable collection of the values in this map, sorted by the ordering of the corresponding keys.

  Specified by:
    `values` in interface `Map<K,V>`
  Specified by:
    `values` in interface `SortedMap<K,V>`
  Specified by:
    `values` in class `ImmutableMap<K,V>`

### comparator

    public Comparator<? super K> comparator()

  Returns the comparator that orders the keys, which is `Ordering.natural()` when the natural ordering of the keys is used. Note that its behavior is not consistent with `TreeMap.comparator()`, which returns `null` to indicate natural ordering.

  Specified by:
    `comparator` in interface `SortedMap<K,V>`

### firstKey

    public K firstKey()

  Specified by:
    `firstKey` in interface `SortedMap<K,V>`

### lastKey

    public K lastKey()

  Specified by:
    `lastKey` in interface `SortedMap<K,V>`

### headMap

    public ImmutableSortedMap<K,V> headMap(K toKey)

  This method returns a `ImmutableSortedMap`, consisting of the entries whose keys are less than `toKey`.

  The `SortedMap.headMap(K)` documentation states that a submap of a submap throws an `IllegalArgumentException` if passed a `toKey` greater than an earlier `toKey`. However, this method doesn't throw an exception in that situation, but instead keeps the original `toKey`.

  Specified by:
    `headMap` in interface `SortedMap<K,V>`

### subMap

    public ImmutableSortedMap<K,V> subMap(K fromKey,
                                          K toKey)

  This method returns a `ImmutableSortedMap`, consisting of the entries whose keys ranges from `fromKey`, inclusive, to `toKey`, exclusive.

  The `SortedMap.subMap(K, K)` documentation states that a submap of a submap throws an `IllegalArgumentException` if passed a `fromKey` less than an earlier `fromKey`. However, this method doesn't throw an exception in that situation, but instead keeps the original `fromKey`. Similarly, this method keeps the original `toKey`, instead of throwing an exception, if passed a `toKey` greater than an earlier `toKey`.

  Specified by:
    `subMap` in interface `SortedMap<K,V>`

### tailMap

    public ImmutableSortedMap<K,V> tailMap(K fromKey)

  This method returns a `ImmutableSortedMap`, consisting of the entries whose keys are greater than or equals to `fromKey`.

  The `SortedMap.tailMap(K)` documentation states that a submap of a submap throws an `IllegalArgumentException` if passed a `fromKey` less than an earlier `fromKey`. However, this method doesn't throw an exception in that situation, but instead keeps the original `fromKey`.

  Specified by:
    `tailMap` in interface `SortedMap<K,V>`

### builder

    @Deprecated
    public static <K,V> ImmutableSortedMap.Builder<K,V> builder()

  Deprecated. Use `naturalOrder()`, which offers better type-safety.

  Not supported. Use `naturalOrder()`, which offers better type-safety, instead. This method exists only to hide `ImmutableMap.builder()` from consumers of `ImmutableSortedMap`.

  Throws:
    `UnsupportedOperationException` - always

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.